> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Submit a data labeling job

POST https://rest.test.zuora.com/v1/multi-organizations/data-labeling-job
Content-Type: application/json

Submits a data labeling job.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/multiple-organizations/data-labeling/post-data-labeling-job

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a SubmitDataLabelingJobRequest.

- `objectType` (string, required) — The object type of the data labeling job. Currently, the following objects are supported: * `User` * `Account` All the associated transaction objects of the account being labeled will automatically inherit the org label of the account. * `Product` You have to label the Account object first, make sure all accounts have been labeled, then you can proceed with the Product object. You can get all the unlabeled accounts by running a Data Source export job, with the following query: ``` sql SELECT Id, Name FROM Account WHERE Organization.Id IS NULL ``` All the ProductRatePlanS of the product will be automatically labeled with the same `orgs`. When labeling products, you can omit the `orgs` parameter, i.e, leave it empty, the system will find all the subscriptions that include the product and get the org list of those subscriptions, then label the product with those `orgs`, aka, the `derived orgs`. You can also explicitly specify the orgs parameter, in that case, you will need to provide a super set of the `derived orgs`. * `BillRun` You don't need to specify the `orgs` parameter, we will label the `BillRun` with all the orgs because existing runs could pick up all accounts. You can definitely create new bill run with certain `orgs` to operate separately by `orgs`. * `PaymentRun` Same as BillRun. * `ForecastRun`
- `queryType` (enum, required) — Specifies the type of query that the data labeling job will run to fetch the data to be labeled. * `ByZoql` - The data labeling job will run a ZOQL query which is specified in the `query` field to fetch the data to be labeled. * `ById` - The data labeling job will fetch the data to be labeled by the IDs specified in the `ids` field.
  - Allowed values: `ByZoql`, `ById`
- `ids` (list of string, optional) — The IDs of the objects to be labeled, only required if the `queryType` is `ById`. There is a 4MB limit of the JSON payload, so in case of a large number of IDs, please make sure the payload is less than 4MB.
- `orgIds` (list of string, optional) — The IDs of the organizations that the data labeling job will associate with the data to be labeled. Either the `orgIds` or `orgs` field is required. For `Account` object, one and only one org Id is required. For configuration objects, `null` and `[]` are treated differently, use `null` to unlabel the object, `[]` to label it with all orgs.
- `orgs` (list of string, optional) — The names of the organizations that the data labeling job will associate with the data to be labeled. Either the `orgIds` or `orgs` field is required. For `Account` object, one and only one org name is required. For configuration objects, `null` and `[]` are treated differently, use `null` to unlabel the object, `[]` to label it with all orgs.
- `query` (string, optional) — The query that the data labeling job will run to fetch the data to be labeled, only required if the `queryType` is `ByZoql`.

## Response

### 200

OK

- `jobId` (string, optional) — Identifier of the data labeling job.
- `jobStatus` (enum, optional) — Status of the data labeling job. * `Accepted` - The data labeling job has been accepted by the system. * `Dispatched` - The data labeling job is dispatched to the data labeling service. * `Completed` - The data labeling job has completed. Please note that `Completed` simply means the data labeling job has completed, but it does not mean the data labeling job has labeled all the data. You can check the `progress` field to see how many data have been `labeled`, `failed` or `timeout`.
  - Allowed values: `Accepted`, `Dispatched`, `Completed`
- `success` (boolean, optional) — Indicates whether the job was submitted successfully.

## Errors

### 400 Bad Request Error

Bad Request

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "objectType": "Account",
  "queryType": "ByZoql",
  "orgIds": [
    "12345678-1234-1234-1234-123456789012"
  ],
  "query": "select Id from Account where BillToContact.Country = 'US'"
}
```

**Response**

```json
{
  "jobId": "ff80808186beca0a0186bedbf7d3006f",
  "jobStatus": "Accepted",
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/multi-organizations/data-labeling-job"

payload = {
    "objectType": "Account",
    "queryType": "ByZoql",
    "orgIds": ["12345678-1234-1234-1234-123456789012"],
    "query": "select Id from Account where BillToContact.Country = 'US'"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/multi-organizations/data-labeling-job';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"objectType":"Account","queryType":"ByZoql","orgIds":["12345678-1234-1234-1234-123456789012"],"query":"select Id from Account where BillToContact.Country = \'US\'"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/multi-organizations/data-labeling-job"

	payload := strings.NewReader("{\n  \"objectType\": \"Account\",\n  \"queryType\": \"ByZoql\",\n  \"orgIds\": [\n    \"12345678-1234-1234-1234-123456789012\"\n  ],\n  \"query\": \"select Id from Account where BillToContact.Country = 'US'\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/multi-organizations/data-labeling-job")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"objectType\": \"Account\",\n  \"queryType\": \"ByZoql\",\n  \"orgIds\": [\n    \"12345678-1234-1234-1234-123456789012\"\n  ],\n  \"query\": \"select Id from Account where BillToContact.Country = 'US'\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/multi-organizations/data-labeling-job")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"objectType\": \"Account\",\n  \"queryType\": \"ByZoql\",\n  \"orgIds\": [\n    \"12345678-1234-1234-1234-123456789012\"\n  ],\n  \"query\": \"select Id from Account where BillToContact.Country = 'US'\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/multi-organizations/data-labeling-job', [
  'body' => '{
  "objectType": "Account",
  "queryType": "ByZoql",
  "orgIds": [
    "12345678-1234-1234-1234-123456789012"
  ],
  "query": "select Id from Account where BillToContact.Country = \'US\'"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/multi-organizations/data-labeling-job");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"objectType\": \"Account\",\n  \"queryType\": \"ByZoql\",\n  \"orgIds\": [\n    \"12345678-1234-1234-1234-123456789012\"\n  ],\n  \"query\": \"select Id from Account where BillToContact.Country = 'US'\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "objectType": "Account",
  "queryType": "ByZoql",
  "orgIds": ["12345678-1234-1234-1234-123456789012"],
  "query": "select Id from Account where BillToContact.Country = 'US'"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/multi-organizations/data-labeling-job")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```